Archive the asset container
POST /v2/asset_containers/archive
Archive the assets database of the asset container.<br/><br/>Archiving the assets database of not used asset containers helps saving storage and computing resources of the database, therefore reduce the footprint of CAMS.The information stored in the archived asset containers will not be accessible until the asset containers are restored.
Request
Request Body
CatalogArchiveCatalogRequest
Archive request
comment
string
Path Parameters
Query Parameters
catalog_id
string
You must provide either a catalog id, a project id, or a space id, but not more than one
project_id
string
You must provide either a catalog id, a project id, or a space id, but not more than one
space_id
string
You must provide either a catalog id, a project id, or a space id, but not more than one
Response
202 - Accepted
state
string
archive_comment
string
archive_file_path
string
archive_schedule_time
string
archive_schedule_time_ticks
integer
archive_stop_time
string
archive_stop_time_ticks
integer
restore_schedule_time
string
restore_schedule_time_ticks
integer
restore_stop_time
string
restore_stop_time_ticks
integer
failed_times
integer
The times that the archive/restore process failed for the asset container. Note that a successful archive/restore will reset this field.
failure
CatalogErrorContainerModel
The details of the error.
400 - Bad Request
401 - Unauthorized
403 - Forbidden
500 - Internal Server Error
Get archive information of the asset container
GET /v2/asset_containers/archive_info
Get archive information of the asset container.
Request
Path Parameters
Query Parameters
catalog_id
string
You must provide either a catalog id, a project id, or a space id, but not more than one
project_id
string
You must provide either a catalog id, a project id, or a space id, but not more than one
space_id
string
You must provide either a catalog id, a project id, or a space id, but not more than one
Response
200 - OK
state
string
archive_comment
string
archive_file_path
string
archive_schedule_time
string
archive_schedule_time_ticks
integer
archive_stop_time
string
archive_stop_time_ticks
integer
restore_schedule_time
string
restore_schedule_time_ticks
integer
restore_stop_time
string
restore_stop_time_ticks
integer
failed_times
integer
The times that the archive/restore process failed for the asset container. Note that a successful archive/restore will reset this field.
failure
CatalogErrorContainerModel
The details of the error.
400 - Bad Request
401 - Unauthorized
403 - Forbidden
500 - Internal Server Error
Get configurations
GET /v2/asset_containers/configurations
Get the configurations of a catalog/project/space.
Request
Path Parameters
Query Parameters
catalog_id
string
You must provide either a catalog id, a project id, or a space id, but not more than one
project_id
string
You must provide either a catalog id, a project id, or a space id, but not more than one
space_id
string
You must provide either a catalog id, a project id, or a space id, but not more than one
Response
200 - OK
duplicate_action
string
Action to take if duplicate assets are found for a given asset
default_duplicate_strategy
string
Default duplicate detection strategy for assets of types that do not have duplicate detection strategy defined
duplicate_strategies
array
Duplicate detection strategies of assets with specified asset types in this catalog/project/space
reporting_authorized
boolean
Authorize reporting in this catalog
default_purge_on_delete
boolean
Whether assets has to be purged on delete
default_purge_after_days
integer
Days after which assets has to be purged after soft delete
400 - Bad Request
401 - Unauthorized
403 - Forbidden
404 - Not Found
Replace or create configurations
PUT /v2/asset_containers/configurations
Replace the configurations of a catalog/project/space or create the configurations if they do not exist.
Request
Request Body
CatalogAssetContainerConfiguration
Configurations
duplicate_action
string
Action to take if duplicate assets are found for a given asset
default_duplicate_strategy
string
Default duplicate detection strategy for assets of types that do not have duplicate detection strategy defined
duplicate_strategies
array
Duplicate detection strategies of assets with specified asset types in this catalog/project/space
reporting_authorized
boolean
Authorize reporting in this catalog
default_purge_on_delete
boolean
Whether assets has to be purged on delete
default_purge_after_days
integer
Days after which assets has to be purged after soft delete
Path Parameters
Query Parameters
catalog_id
string
You must provide either a catalog id, a project id, or a space id, but not more than one
project_id
string
You must provide either a catalog id, a project id, or a space id, but not more than one
space_id
string
You must provide either a catalog id, a project id, or a space id, but not more than one
Response
200 - OK
duplicate_action
string
Action to take if duplicate assets are found for a given asset
default_duplicate_strategy
string
Default duplicate detection strategy for assets of types that do not have duplicate detection strategy defined
duplicate_strategies
array
Duplicate detection strategies of assets with specified asset types in this catalog/project/space
reporting_authorized
boolean
Authorize reporting in this catalog
default_purge_on_delete
boolean
Whether assets has to be purged on delete
default_purge_after_days
integer
Days after which assets has to be purged after soft delete
400 - Bad Request
401 - Unauthorized
403 - Forbidden
500 - Internal Server Error
Restore the asset container
POST /v2/asset_containers/restore
Restore the assets database of the archived asset container. Only successfully archived asset container can be restored.
Request
Path Parameters
Query Parameters
catalog_id
string
You must provide either a catalog id, a project id, or a space id, but not more than one
project_id
string
You must provide either a catalog id, a project id, or a space id, but not more than one
space_id
string
You must provide either a catalog id, a project id, or a space id, but not more than one
Response
200 - OK
state
string
archive_comment
string
archive_file_path
string
archive_schedule_time
string
archive_schedule_time_ticks
integer
archive_stop_time
string
archive_stop_time_ticks
integer
restore_schedule_time
string
restore_schedule_time_ticks
integer
restore_stop_time
string
restore_stop_time_ticks
integer
failed_times
integer
The times that the archive/restore process failed for the asset container. Note that a successful archive/restore will reset this field.
failure
CatalogErrorContainerModel
The details of the error.
202 - Accepted
state
string
archive_comment
string
archive_file_path
string
archive_schedule_time
string
archive_schedule_time_ticks
integer
archive_stop_time
string
archive_stop_time_ticks
integer
restore_schedule_time
string
restore_schedule_time_ticks
integer
restore_stop_time
string
restore_stop_time_ticks
integer
failed_times
integer
The times that the archive/restore process failed for the asset container. Note that a successful archive/restore will reset this field.
failure
CatalogErrorContainerModel
The details of the error.
400 - Bad Request
401 - Unauthorized
403 - Forbidden
500 - Internal Server Error
List all asset lists defined for an account
GET /v2/asset_lists
Retrieve a paginated list of asset lists defined for an account.
Request
Path Parameters
Query Parameters
query
string
Query to retrieve a paginated list of asset list metadatas for which the request user has permission to view.<br/><br/>Search query in Common Expression Language, with special characters encoded. For example, & is %26.<br/><br/>Examples of query parameters:<br/>* id<br/>* type<br/>* state<br/>* access_control.owner<br/>* created_at<br/>* last_updated_at
start
string
Start token for pagination
limit
integer
Search result limit
sort
This parameter can be repeated to add additional sort fields. <br><br>Default: null
Examples of sort fields (these are case insensitive):
- created_at
- -created_at
- last_updated_at
- -last_updated_at
Response
200 - OK
limit
integer
The limit on the number of results returned.
total_count
integer
The total count on the number of results returned, accounting for filtering but not pagination.
first
CatalogBaseCollectionPage
A page in a pagination collection.
next
CatalogBaseCollectionNextPage
The next page in the collection.
asset_lists
array
Collection of asset list results.
400 - Bad Request
trace
string
Trace (transaction) ID for the failed operation
errors
array
Errors thrown during the operation
401 - Unauthorized
trace
string
Trace (transaction) ID for the failed operation
errors
array
Errors thrown during the operation
403 - Forbidden
trace
string
Trace (transaction) ID for the failed operation
errors
array
Errors thrown during the operation
500 - Internal Server Error
trace
string
Trace (transaction) ID for the failed operation
errors
array
Errors thrown during the operation
Create a new asset list
POST /v2/asset_lists
Use this API to creates a new asset list.<br/><br/>If the `state` is not specified, the asset list will be created in DEFAULT state.<br/>The list may be created with items, or without items.<br/>The list will be owned by the request user.
Request
Request Body
CatalogAssetListPrototype
The asset list for creation.
name
Required *
string
Asset list name. A name can contain letters, numbers, understores, dashes, spaces or periods. Names are mutable and reusable.
description
string
A description of the asset list.
type
Required *
string
The type of the asset list. Valid types are: ['order', 'cart', 'wishlist']
state
string
The state of the asset list. Valid states are: ['default_state', 'confirmed']. If not specified, the default value will be 'DEFAULT'.
message
string
A message used for communicating reasons for state changes.
properties
CatalogPropertiesObject
The properties of an asset list item.
asset
CatalogAssetReference
An asset from a container.
id
Required *
string
The unique identifier of the asset formatted as a UUID.
type
string
The type (primary attribute) of the asset
container
object
The container for the asset ('catalog', 'project' or 'space').
items
array
The items in the asset list.
Response
201 - Created
name
string
Asset list name. A name can contain letters, numbers, understores, dashes, spaces or periods. Names are mutable and reusable.
description
string
A description of the asset list.
type
string
The type of the asset list. Valid types are: ['order', 'cart', 'wishlist']
state
string
The state of the asset list. Valid states are: ['default_state', 'confirmed']. If not specified, the default value will be 'DEFAULT'.
message
string
A message used for communicating reasons for state changes.
properties
CatalogPropertiesObject
The properties of an asset list item.
id
string
The unique identifier of the asset list formatted either as a UUID or a special case such as cart_userID.
asset
CatalogAssetReference
An asset from a container.
access_control
CatalogAssetListAccessControl
Access control permissions for the asset list.
created_at
string
RFC 3339 timestamp when the asset list was created (system managed).
last_updated_at
string
RFC 3339 timestamp when the asset list was last updated (system managed).
last_updated_by
string
The user who last updated the asset list.
400 - Bad Request
trace
string
Trace (transaction) ID for the failed operation
errors
array
Errors thrown during the operation
401 - Unauthorized
trace
string
Trace (transaction) ID for the failed operation
errors
array
Errors thrown during the operation
403 - Forbidden
trace
string
Trace (transaction) ID for the failed operation
errors
array
Errors thrown during the operation
409 - Conflict
trace
string
Trace (transaction) ID for the failed operation
errors
array
Errors thrown during the operation
429 - Too Many Requests
trace
string
Trace (transaction) ID for the failed operation
errors
array
Errors thrown during the operation
500 - Internal Server Error
trace
string
Trace (transaction) ID for the failed operation
errors
array
Errors thrown during the operation
Delete asset lists
DELETE /v2/asset_lists
Deletes asset lists based on a query in Common Expression Language format.
Request
Path Parameters
Query Parameters
query
string
Query to delete asset lists for which the request user has permission.<br/><br/>Search query in Common Expression Language, with special characters encoded. For example, & is %26.<br/><br/>Examples of query parameters:<br/>* id<br/>* type<br/>* state<br/>* access_control.owner<br/>* created_at<br/>* last_updated_at
Response
204 - No Content
400 - Bad Request
trace
string
Trace (transaction) ID for the failed operation
errors
array
Errors thrown during the operation
401 - Unauthorized
trace
string
Trace (transaction) ID for the failed operation
errors
array
Errors thrown during the operation
403 - Forbidden
trace
string
Trace (transaction) ID for the failed operation
errors
array
Errors thrown during the operation
404 - Not Found
trace
string
Trace (transaction) ID for the failed operation
errors
array
Errors thrown during the operation
429 - Too Many Requests
trace
string
Trace (transaction) ID for the failed operation
errors
array
Errors thrown during the operation
500 - Internal Server Error
trace
string
Trace (transaction) ID for the failed operation
errors
array
Errors thrown during the operation
Retrieve an asset list identified by ID
GET /v2/asset_lists/{asset_list_id}
Retrieves the metadata of an asset list of a given identified by ID.
Request
Response
200 - OK
name
string
Asset list name. A name can contain letters, numbers, understores, dashes, spaces or periods. Names are mutable and reusable.
description
string
A description of the asset list.
type
string
The type of the asset list. Valid types are: ['order', 'cart', 'wishlist']
state
string
The state of the asset list. Valid states are: ['default_state', 'confirmed']. If not specified, the default value will be 'DEFAULT'.
message
string
A message used for communicating reasons for state changes.
properties
CatalogPropertiesObject
The properties of an asset list item.
id
string
The unique identifier of the asset list formatted either as a UUID or a special case such as cart_userID.
asset
CatalogAssetReference
An asset from a container.
access_control
CatalogAssetListAccessControl
Access control permissions for the asset list.
created_at
string
RFC 3339 timestamp when the asset list was created (system managed).
last_updated_at
string
RFC 3339 timestamp when the asset list was last updated (system managed).
last_updated_by
string
The user who last updated the asset list.
400 - Bad Request
trace
string
Trace (transaction) ID for the failed operation
errors
array
Errors thrown during the operation
401 - Unauthorized
trace
string
Trace (transaction) ID for the failed operation
errors
array
Errors thrown during the operation
403 - Forbidden
trace
string
Trace (transaction) ID for the failed operation
errors
array
Errors thrown during the operation
404 - Not Found
trace
string
Trace (transaction) ID for the failed operation
errors
array
Errors thrown during the operation
500 - Internal Server Error
trace
string
Trace (transaction) ID for the failed operation
errors
array
Errors thrown during the operation
Delete an asset list identified by ID
DELETE /v2/asset_lists/{asset_list_id}
Deletes an asset list identified by ID. The user must have permission to perform this action.
Request
Response
204 - No Content
400 - Bad Request
trace
string
Trace (transaction) ID for the failed operation
errors
array
Errors thrown during the operation
401 - Unauthorized
trace
string
Trace (transaction) ID for the failed operation
errors
array
Errors thrown during the operation
403 - Forbidden
trace
string
Trace (transaction) ID for the failed operation
errors
array
Errors thrown during the operation
404 - Not Found
trace
string
Trace (transaction) ID for the failed operation
errors
array
Errors thrown during the operation
409 - Conflict
trace
string
Trace (transaction) ID for the failed operation
errors
array
Errors thrown during the operation
429 - Too Many Requests
trace
string
Trace (transaction) ID for the failed operation
errors
array
Errors thrown during the operation
500 - Internal Server Error
trace
string
Trace (transaction) ID for the failed operation
errors
array
Errors thrown during the operation
PATCH /v2/asset_lists/{asset_list_id}
Use this API to update the asset list metadata. Specify patch operations using http://jsonpatch.com/ syntax.
Fields that can be patched:
- /name
- /description
- /type
- /state (Approvers and Functional users only)
- /message (Approvers and Functional users only)
Note: The ownership cannot be modified after creation.
Request
Request Body
JSON array of patch operations as defined in RFC 6902. See http://jsonpatch.com/ for more info.
Response
200 - OK
name
string
Asset list name. A name can contain letters, numbers, understores, dashes, spaces or periods. Names are mutable and reusable.
description
string
A description of the asset list.
type
string
The type of the asset list. Valid types are: ['order', 'cart', 'wishlist']
state
string
The state of the asset list. Valid states are: ['default_state', 'confirmed']. If not specified, the default value will be 'DEFAULT'.
message
string
A message used for communicating reasons for state changes.
properties
CatalogPropertiesObject
The properties of an asset list item.
id
string
The unique identifier of the asset list formatted either as a UUID or a special case such as cart_userID.
asset
CatalogAssetReference
An asset from a container.
access_control
CatalogAssetListAccessControl
Access control permissions for the asset list.
created_at
string
RFC 3339 timestamp when the asset list was created (system managed).
last_updated_at
string
RFC 3339 timestamp when the asset list was last updated (system managed).
last_updated_by
string
The user who last updated the asset list.
400 - Bad Request
trace
string
Trace (transaction) ID for the failed operation
errors
array
Errors thrown during the operation
401 - Unauthorized
trace
string
Trace (transaction) ID for the failed operation
errors
array
Errors thrown during the operation
403 - Forbidden
trace
string
Trace (transaction) ID for the failed operation
errors
array
Errors thrown during the operation
409 - Conflict
trace
string
Trace (transaction) ID for the failed operation
errors
array
Errors thrown during the operation
415 - Unsupported Media Type
trace
string
Trace (transaction) ID for the failed operation
errors
array
Errors thrown during the operation
500 - Internal Server Error
trace
string
Trace (transaction) ID for the failed operation
errors
array
Errors thrown during the operation
List the items of an asset list identified by ID
GET /v2/asset_lists/{asset_list_id}/items
Retrieves the list items of an asset list identified by ID.
Request
Path Parameters
asset_list_id
Required *
string
Asset list id (GUID, or [type]_[userId])
Query Parameters
query
string
Query to retrieve a paginated list of asset list items for which the request user has permission to view.<br/><br/>Search query in Common Expression Language, with special characters encoded. For example, & is %26.<br/><br/>
start
string
Start token for pagination
limit
integer
Search result limit
sort
This parameter can be repeated to add additional sort fields. <br><br>Default: null
Examples of sort fields (these are case insensitive):
- created_at
- -created_at
- last_update_time
- -last_update_time
Response
200 - OK
limit
integer
The limit on the number of results returned.
total_count
integer
The total count on the number of results returned, accounting for filtering but not pagination.
first
CatalogBaseCollectionPage
A page in a pagination collection.
next
CatalogBaseCollectionNextPage
The next page in the collection.
items
array
Collection of asset list item results.
400 - Bad Request
trace
string
Trace (transaction) ID for the failed operation
errors
array
Errors thrown during the operation
401 - Unauthorized
trace
string
Trace (transaction) ID for the failed operation
errors
array
Errors thrown during the operation
403 - Forbidden
trace
string
Trace (transaction) ID for the failed operation
errors
array
Errors thrown during the operation
404 - Not Found
trace
string
Trace (transaction) ID for the failed operation
errors
array
Errors thrown during the operation
500 - Internal Server Error
trace
string
Trace (transaction) ID for the failed operation
errors
array
Errors thrown during the operation
Retrieve an item in an asset list
GET /v2/asset_lists/{asset_list_id}/items/{asset_list_item_id}
Retrieves an item identified by ID of an asset list identified by ID.
Request
Response
200 - OK
asset
CatalogAssetReference
An asset from a container.
properties
CatalogPropertiesObject
The properties of an asset list item.
id
string
The unique identifier of the asset list item formatted as a UUID.
access_control
CatalogAssetListAccessControl
Access control permissions for the asset list.
created_at
string
RFC 3339 timestamp when the asset list item was created (system managed).
last_updated_at
string
RFC 3339 timestamp when the asset list item was last updated (system managed).
last_updated_by
string
The user who last updated the asset list item.
asset_list
object
The reference to the asset list to which the item belongs.
400 - Bad Request
trace
string
Trace (transaction) ID for the failed operation
errors
array
Errors thrown during the operation
401 - Unauthorized
trace
string
Trace (transaction) ID for the failed operation
errors
array
Errors thrown during the operation
403 - Forbidden
trace
string
Trace (transaction) ID for the failed operation
errors
array
Errors thrown during the operation
404 - Not Found
trace
string
Trace (transaction) ID for the failed operation
errors
array
Errors thrown during the operation
500 - Internal Server Error
trace
string
Trace (transaction) ID for the failed operation
errors
array
Errors thrown during the operation
PATCH /v2/asset_lists/{asset_list_id}/items/{asset_list_item_id}
Use this API to update an asset list item. Specify patch operations using http://jsonpatch.com/ syntax.
Fields that can be patched:
- /properties
Request
Request Body
JSON array of patch operations as defined in RFC 6902. See http://jsonpatch.com/ for more info.
Response
200 - OK
asset
CatalogAssetReference
An asset from a container.
properties
CatalogPropertiesObject
The properties of an asset list item.
id
string
The unique identifier of the asset list item formatted as a UUID.
access_control
CatalogAssetListAccessControl
Access control permissions for the asset list.
created_at
string
RFC 3339 timestamp when the asset list item was created (system managed).
last_updated_at
string
RFC 3339 timestamp when the asset list item was last updated (system managed).
last_updated_by
string
The user who last updated the asset list item.
asset_list
object
The reference to the asset list to which the item belongs.
400 - Bad Request
trace
string
Trace (transaction) ID for the failed operation
errors
array
Errors thrown during the operation
401 - Unauthorized
trace
string
Trace (transaction) ID for the failed operation
errors
array
Errors thrown during the operation
403 - Forbidden
trace
string
Trace (transaction) ID for the failed operation
errors
array
Errors thrown during the operation
415 - Unsupported Media Type
trace
string
Trace (transaction) ID for the failed operation
errors
array
Errors thrown during the operation
500 - Internal Server Error
trace
string
Trace (transaction) ID for the failed operation
errors
array
Errors thrown during the operation
GET /v2/asset_relationship_types
Searches for relationship types using various criteria. The query parameters here provide filters for the relationship types that are returned in the result. If no query parameters are provided, the result will include all relationship types that are visible to your bss account. If an asset container is specified, the results are limited to relationship types where at least one end can be used with the specified asset container. This is the case if the relationship end either has no declared asset container (for example because the end references a global asset type or is untyped) or if the end has an asset container that is the same as the asset container specified. If a `relname` filter is specified, the results are limited to relationship types where at least one end has a relationship name in the list. In order to see relationship types where at least one end is in the container asset type(s), you must either belong to the container's BSS account or have at least editor permission on the container. All users have permission to see global relationship types.
Limit the relationship types based on the item types:
- If the `asset_type` is specified, the results are limited to relationship types where at least one end is either untyped or is in the specified asset type list.
- If both `asset_type` and `related_asset_type` are specified, the results are limited to relationship types where both ends are untyped, or where one end is in the specified asset type list and the other end has the specified asset type list.
- If the `artifact_type` is specified, the results are limited to relationship types where at least one end is either untyped or is in the specified artifact type list.
- If both `artifact_type` and `related_asset_type` are specified, the results are limited to relationship types where both ends are untyped, or where one end is in the specified artifact type list and the other end has the specified asset type list.
- If the `asset_type` or `related_asset_type` is set to `*#_column`, the results are limited to relationship types where one end can be used with any supported column type (currently limited to `data_asset` columns)
- If the item type is set to `*`, the results are limited to relationship types where one end can be used with any asset type or any artifact type.
Note: In CP4D environments there is just one global bss account, so all relationship types are always visible to all users.
Request
Path Parameters
Query Parameters
container_type
string
Required when container_id is specified and the container is not a catalog. Specifies the type of the container (CATALOG/PROJECT/SPACE). Defaults to CATALOG.
container_id
string
Container ID. This limits results to relationship types that have an endpoint with the specified ID of a catalog, project, or space. If the container is a project or space, the container_type parameter must be also specified, otherwise container_id is treated as a catalog ID. This parameter is required when querying for relationship types associated with a catalog, project, or space. If this parameter is omitted, relationships types are not filtered by their container. Note that any type with an endpoint that has no container ID will also be included the result.
type_name
string
The parameter `type_name` is deprecated, please use `asset_type` instead
asset_type
array
Asset Type Name(s). This limits the results to only relationship types that have an endpoint in the specified asset type list, or have an endpoint that is untyped.
artifact_type
array
Artifact Type Name(s). This limits the results to only relationship types that have an endpoint in the specified artifact type list, or have an endpoint that is untyped.
related_asset_type
array
Related Asset Type Name(s). This parameter can only be set when either asset_type or artifact_type is also set.
When asset_type is set, this limits the results to only relationship types that have an endpoint with the specified asset type and the other endpoint with this specified asset type.
When artifact_type is set, this limits the results to only relationship types that have an endpoint with the specified artifact type and the other endpoint with this specified asset type.
limit
integer
limit to use when finding relationship types
bookmark
string
Optional bookmark to use when finding relationship types.
relname
array
Relationship name(s). This limits the results to relationship types that have an endpoint with the specified name. The parameter should be repeated for each allowed relationship name.
default_display_name
array
Default display name(s). This limits the results to relationship types that have an endpoint with the specified name. The parameter should be repeated for each allowed relationship name.
scope
string
Specifies the scope of the relationship types which can be (GLOBAL/BSS_ACCOUNT). If GLOBAL - it returns all types scoped to Global.If BSS_ACCOUNT - it returns all types scoped to BSS_ACCOUNT.If query parameter is omitted, it returns all.
bss_account_id
string
If specified, the results are limited to relationship types that can be accessed by the specified BSS account. If `container_id` is also specified, the catalog's BSS account must be the same as the BSS account specified here.
If `bss_account_id` is not specified and the API is called with an accredited service ID access token, then there is no filtering of the results based on BSS account.
If `bss_account_id` is not specified, and the API is called with a regular user (i.e. non-service ID) access token, then the result depends on whether `container_id` is specified. If `container_id` is specified, then the result includes global relationship types and account-scoped relationship types for the container's BSS account. If `container_id` is not specified, then the result includes global relationship types, and account-scoped relationship types for all of the user's BSS accounts.
Response
200 - Success
resources
array
relationship types that match the search criteria
total_rows
integer
total number of rows in the search result
next
object
URL to fetch the next page of search results
400 - Bad Request
401 - Unauthorized
403 - Forbidden
409 - Conflict
429 - Too Many Requests
The combination of `container_type`, `container_id`, and `containing_asset_type(s)` control what asset types can be used at each end of the relationship. The asset type can be a global asset type, an account-level asset type, a container-scoped asset type, or any asset type.
Global Asset Type
To define a relationship end for a global asset type, the `containing_asset_type(s)` field must be set to the name of the asset type and the `container_id` must be omitted. In this case, the relationship end can only be used with the specified global asset type. If the `container_type` field is set when using a global asset type, it is ignored.
Account Level Asset Type
To define a relationship end for an account-level asset type, the `containing_asset_type(s)` field must be set to the name of the asset type and the `container_id` must be omitted. In addition, the `bss_account_id` query parameter must be set to the bss account that owns the account-level asset type. In this case, the relationship end can only be used with the specified account-level asset type. If the `container_type` field is set when using an account-level asset type, it is ignored.
Container-Scoped Asset Type
The relationship mechanism allows relationship ends to be restricted to an asset type defined in a specific catalog, project, or space. To do this, the `containing_asset_type(s)`, `container_type`, and `container_id` fields must all be set.
Artifact Type
To define a relationship end for an governance artifact type, the `containing_artifact_type(s)` field must be set to the name of the artifact type and the `container_id` must be omitted. The on_delete field can only set to IGNORE on both ends
Column Type
To define a relationship end for a column type, the `containing_asset_type(s)` field must be set in the format of `<asset_type>#_column`. When `*#_column` is specified, the relationship end can be used with any supported column type. Currently, only `data_asset` columns are supported. The `on_delete` field can only set to `IGNORE` on both ends
Any Type
To allow a relationship end to be used with any asset type, the `containing_artifact_type(s)`, `containing_asset_type(s)` and `container_id` fields for the relationship end must be omitted. In this case, the relationship end can be used with any asset type, any artifact type, and any supported column type in any container. If the `container_type` field is set, it will be ignored.
Note: Cannot have `containing_artifact_type(s)` specified in both ends
Specifying the Relationship Type Scope
A relationship type can either be global or be scoped to a BSS account.
A relationship type can be explicitly scoped to a specific bss account using the `bss_account_id` query parameter. When a relationship type is scoped to a bss account, all specified asset containers and account-level asset types must belong to that bss account. If either endpoint for the relationship type has a specific asset container, the relationship type is automatically scoped to the bss account for the asset container. Account scoped relationship types can only be created if the user either belongs to the same bss account or is an administrator of all asset containers in the relationship type definition.
By default, if neither end of the relationship type specifies an asset container, the relationship type is created in the global scope and is accessible to all users. Only service ids with permission to create global asset types are allowed to create globally scoped relationship types. It is possible to scope a relationship type where neither end has an asset container to a specific BSS account. To do this, you must set the `bss_account_id` query parameter when creating the relationship type. The bss account must be set to a bss account that you have access to. In that case, the relationship type will be created, but its use will be restricted to asset containers associated with that bss account.
By default, on_delete is set to `IGNORE` if it is not specified
Note that in CP4D environments, there is only one bss account (`999`). As a result, in that context relationship types scoped to a specific BSS account are effectively global.
Cascading clone/publish/promote to Referenced Assets
The following flags control how related assets are processed when an asset is copied using the `deepcopy` endpoint
| Option | Allowed Value | Default | Description |
|---|---|---|---|
| on_clone | CASCADE/IGNORE | IGNORE | If CASCADE, deepcopy from a catalog to a project causes the referenced assets to be copied as well |
| on_publish | CASCADE/IGNORE | IGNORE | If CASCADE, deepcopy from project to a catalog causes the referenced assets to be copied as well |
| on_promote | CASCADE/IGNORE | IGNORE | If CASCADE, deepcopy from a project to a space causes the referenced assets to be coped as well |
">
Creates an asset relationship type
POST /v2/asset_relationship_types
Use this API to create an asset relationship type. The type definition consists of two endpoints which specify the two ends of a bidirectional relationship. The endpoints define the name of the relationship at each end, and the qualified asset type or the qualified artifact type that contains the relationship endpoint. The names of the relationships that can be used with any given asset type or artifact type are required to be unique. If the qualified asset type and the qualified artifact type are omitted, that end can be used with any asset type and any artifact type in any container.
Specifying the Type
The combination of `container_type`, `container_id`, and `containing_asset_type(s)` control what asset types can be used at each end of the relationship. The asset type can be a global asset type, an account-level asset type, a container-scoped asset type, or any asset type.
Global Asset Type
To define a relationship end for a global asset type, the `containing_asset_type(s)` field must be set to the name of the asset type and the `container_id` must be omitted. In this case, the relationship end can only be used with the specified global asset type. If the `container_type` field is set when using a global asset type, it is ignored.
Account Level Asset Type
To define a relationship end for an account-level asset type, the `containing_asset_type(s)` field must be set to the name of the asset type and the `container_id` must be omitted. In addition, the `bss_account_id` query parameter must be set to the bss account that owns the account-level asset type. In this case, the relationship end can only be used with the specified account-level asset type. If the `container_type` field is set when using an account-level asset type, it is ignored.
Container-Scoped Asset Type
The relationship mechanism allows relationship ends to be restricted to an asset type defined in a specific catalog, project, or space. To do this, the `containing_asset_type(s)`, `container_type`, and `container_id` fields must all be set.
Artifact Type
To define a relationship end for an governance artifact type, the `containing_artifact_type(s)` field must be set to the name of the artifact type and the `container_id` must be omitted. The on_delete field can only set to IGNORE on both ends
Column Type
To define a relationship end for a column type, the `containing_asset_type(s)` field must be set in the format of `<asset_type>#_column`. When `*#_column` is specified, the relationship end can be used with any supported column type. Currently, only `data_asset` columns are supported. The `on_delete` field can only set to `IGNORE` on both ends
Any Type
To allow a relationship end to be used with any asset type, the `containing_artifact_type(s)`, `containing_asset_type(s)` and `container_id` fields for the relationship end must be omitted. In this case, the relationship end can be used with any asset type, any artifact type, and any supported column type in any container. If the `container_type` field is set, it will be ignored.
Note: Cannot have `containing_artifact_type(s)` specified in both ends
Specifying the Relationship Type Scope
A relationship type can either be global or be scoped to a BSS account.
A relationship type can be explicitly scoped to a specific bss account using the `bss_account_id` query parameter. When a relationship type is scoped to a bss account, all specified asset containers and account-level asset types must belong to that bss account. If either endpoint for the relationship type has a specific asset container, the relationship type is automatically scoped to the bss account for the asset container. Account scoped relationship types can only be created if the user either belongs to the same bss account or is an administrator of all asset containers in the relationship type definition.
By default, if neither end of the relationship type specifies an asset container, the relationship type is created in the global scope and is accessible to all users. Only service ids with permission to create global asset types are allowed to create globally scoped relationship types. It is possible to scope a relationship type where neither end has an asset container to a specific BSS account. To do this, you must set the `bss_account_id` query parameter when creating the relationship type. The bss account must be set to a bss account that you have access to. In that case, the relationship type will be created, but its use will be restricted to asset containers associated with that bss account.
By default, on_delete is set to `IGNORE` if it is not specified
Note that in CP4D environments, there is only one bss account (`999`). As a result, in that context relationship types scoped to a specific BSS account are effectively global.
Cascading clone/publish/promote to Referenced Assets
The following flags control how related assets are processed when an asset is copied using the `deepcopy` endpoint
| Option | Allowed Value | Default | Description |
|---|---|---|---|
| on_clone | CASCADE/IGNORE | IGNORE | If CASCADE, deepcopy from a catalog to a project causes the referenced assets to be copied as well |
| on_publish | CASCADE/IGNORE | IGNORE | If CASCADE, deepcopy from project to a catalog causes the referenced assets to be copied as well |
| on_promote | CASCADE/IGNORE | IGNORE | If CASCADE, deepcopy from a project to a space causes the referenced assets to be coped as well |
Request
Request Body
CatalogRelationshipTypeEntity
Relationship Type request body
end1
Required *
object
First relationship type endpoint (order is not important)
default_display_name
Required *
string
Default display name for this end of the relationship. This is what will be shown in the UI.
localized_display_name
object
Map of localized display names, keyed on the ISO 639 language code (e.g. "zh")
relationship_name
Required *
string
Internal, non-translated, name for this end of the relationship. This becomes part of the path in the APIs for manipulating and querying relationship types.
containing_artifact_type
string
Optionally specifies the type of the artifact that contains this relationship. If omitted with containing_artifact_types, any artifact types are allowed.
containing_artifact_types
array
Optionally specify the types of the artifacts that contain this relationship. If omitted with containing_artifact_type, any artifact types are allowed.
container_id
string
Specifies the catalog, project, or space id that contains the asset type. This is only required if the asset type is scoped to a particular catalog, project, or space. It is not allowed for global asset types, for example data_asset.
container_type
string
Specifies the type of the container which contains the asset type. This field is required if the container_id is set. It is ignored if the container_id is unset. Allowed values: 'CATALOG', 'SPACE', 'PROJECT'
multiplicity
Required *
string
Multiplicity of this end of the relationship. This controls how many targets the relationship can point to.
displayInChild
boolean
Whether the relationship attribute is displayed in child asset.
on_delete
string
Determines processing of the relationship target when the source object is deleted. Allowed values: CASCADE - delete the referenced object, IGNORE - do not delete the referenced object. Default: IGNORE
on_clone
string
Determines processing of the relationship target when the source object is cloned. Allowed values: CASCADE - clone the referenced object, IGNORE - do not clone the referenced object. Default: IGNORE
on_catalog_clone
string
Determines processing of the relationship target when the source object is cloned to a target catalog. Allowed values: CASCADE - clone the referenced object, IGNORE - do not clone the referenced object. Default: IGNORE
on_publish
string
Determines processing of the relationship target when the source object is published. Allowed values: CASCADE - publish the referenced object, IGNORE - do not publish the referenced object. Default: IGNORE
on_promote
string
Determines processing of the relationship target when the source object is promoted. Allowed values: CASCADE - promote the referenced object, IGNORE - do not promote the referenced object. Default: IGNORE
option_overrides
array
Optionally specifies any override of cascade behavior on `delete, clone, promote and publish` based on specific asset type pairs Note: All duplicate elements will be ignored by the option_overrides `Set` when provided via create or patch REST API(s)
containing_asset_types
array
Optionally specify the types of the assets that contain this relationship. If omitted with containing_asset_type, any asset types are allowed.
containing_asset_type
string
Optionally specifies the type of the asset that contains this relationship. If omitted with containing_asset_types, any asset types are allowed.
end2
Required *
object
Second relationship type endpoint (order is not important)
default_display_name
Required *
string
Default display name for this end of the relationship. This is what will be shown in the UI.
localized_display_name
object
Map of localized display names, keyed on the ISO 639 language code (e.g. "zh")
relationship_name
Required *
string
Internal, non-translated, name for this end of the relationship. This becomes part of the path in the APIs for manipulating and querying relationship types.
containing_artifact_type
string
Optionally specifies the type of the artifact that contains this relationship. If omitted with containing_artifact_types, any artifact types are allowed.
containing_artifact_types
array
Optionally specify the types of the artifacts that contain this relationship. If omitted with containing_artifact_type, any artifact types are allowed.
container_id
string
Specifies the catalog, project, or space id that contains the asset type. This is only required if the asset type is scoped to a particular catalog, project, or space. It is not allowed for global asset types, for example data_asset.
container_type
string
Specifies the type of the container which contains the asset type. This field is required if the container_id is set. It is ignored if the container_id is unset. Allowed values: 'CATALOG', 'SPACE', 'PROJECT'
multiplicity
Required *
string
Multiplicity of this end of the relationship. This controls how many targets the relationship can point to.
displayInChild
boolean
Whether the relationship attribute is displayed in child asset.
on_delete
string
Determines processing of the relationship target when the source object is deleted. Allowed values: CASCADE - delete the referenced object, IGNORE - do not delete the referenced object. Default: IGNORE
on_clone
string
Determines processing of the relationship target when the source object is cloned. Allowed values: CASCADE - clone the referenced object, IGNORE - do not clone the referenced object. Default: IGNORE
on_catalog_clone
string
Determines processing of the relationship target when the source object is cloned to a target catalog. Allowed values: CASCADE - clone the referenced object, IGNORE - do not clone the referenced object. Default: IGNORE
on_publish
string
Determines processing of the relationship target when the source object is published. Allowed values: CASCADE - publish the referenced object, IGNORE - do not publish the referenced object. Default: IGNORE
on_promote
string
Determines processing of the relationship target when the source object is promoted. Allowed values: CASCADE - promote the referenced object, IGNORE - do not promote the referenced object. Default: IGNORE
option_overrides
array
Optionally specifies any override of cascade behavior on `delete, clone, promote and publish` based on specific asset type pairs Note: All duplicate elements will be ignored by the option_overrides `Set` when provided via create or patch REST API(s)
containing_asset_types
array
Optionally specify the types of the assets that contain this relationship. If omitted with containing_asset_type, any asset types are allowed.
containing_asset_type
string
Optionally specifies the type of the asset that contains this relationship. If omitted with containing_asset_types, any asset types are allowed.
flags
object
Set of flags. These flags determine the relationship type's behavior
description
string
Description of the relationship type
Path Parameters
Query Parameters
bss_account_id
string
This parameter forces the relationship type to be scoped to the specified bss account. It allows the creation of an account-scoped relationship type where both ends are either untyped, or are global asset types. It is required if the relationship type entity references any account-level asset types. An account-scoped relationship type is only visible to users in the BSS account for the relationship type. If the query parameter is unset, such relationships will be global in scope and can only be created if the user has permission to create a global asset type. Note: the BSS account can also be set via an impersonation header. If it is set in both places, the `bss_account_id` query parameter has precedence. This parameter is not required if either end of the relationship type has a catalog asset type. If it is set for a relationship type that has a catalog asset type, it must be the same as the BSS account for the catalog.
Response
201 - Created
metadata
object
relationship type metadata
entity
object
relationship type entity
400 - Bad Request
401 - Unauthorized
403 - Forbidden
409 - Conflict
429 - Too Many Request
- set `asset_type` as `<asset_type>#_column`
- if `asset_type` is specific to a container (catalog, space, or project), then set a container ID parameter as appropriate (`catalog_id`, `space_id`, `project_id`).
For a governance artifact type:
- set `artifact_type`. This parameter should be repeated for each allowed artifact type
">
Searches for relationship type ends
POST /v2/asset_relationship_types/search_ends
Find relationship type ends that can be used with an asset type or artifact type. This API supports finding relationship type ends that use global or catalog asset types.
For an asset type:
- set `asset_type`. This parameter should be repeated for each allowed asset type
- All asset types in the list must either be global/account level asset types or be scoped to the asset container specified by the `catalog_id`, `project_id`, or `space_id`.
For a column type:
- set `asset_type` as `<asset_type>#_column`
- if `asset_type` is specific to a container (catalog, space, or project), then set a container ID parameter as appropriate (`catalog_id`, `space_id`, `project_id`).
For a governance artifact type:
- set `artifact_type`. This parameter should be repeated for each allowed artifact type
Request
Path Parameters
Query Parameters
catalog_id
string
catalog_id. If no container parameters are set, any asset container the user has access to are allowed.
project_id
string
project_id. If no container parameters are set, any asset containers the user has access to are allowed.
space_id
string
space_id. If no container parameters are set, any asset containers the user has access to are allowed.
asset_type
array
asset_type(s). This specifies the asset type(s) whose relationship type ends should be found. This parameter should be repeated for each allowed asset type.
artifact_type
array
artifact_type(s). This specifies the artifact type(s) whose relationship type ends should be found. This parameter should be repeated for each allowed artifact type.
end_types
array
end_types. This filters the result to only include relationship type ends of the specified type(s) - valid filter values are {ASSET, ARTIFACT, COLUMN}. If this parameter is not specified, all relationship ends that match other criteria will be returned.
limit
integer
Optional limit to use when finding relationship type ends
bookmark
string
Optional bookmark to use when finding relationship type ends.
orderby
array
orderby. This parameter can be repeated to add additional sort fields. <br><br>Default: relationship_display_name_asc
Supported sort fields (these are case insensitive):
- relationship_name_asc
- relationship_name_desc
- relationship_display_name_asc
- relationship_display_name_desc
- create_time_asc
- create_time_desc
relationship_names
array
Limits results to only include the specified relationships. By default, all relationship type ends which match the other search criteria are included. Repeat the query parameter to specify multiple relationship names.
Response
200 - Success
options
object
related_artifact_types
array
related_asset_types
array
related_column_types
array
resources
array
total_rows
integer
next
object
400 - Bad Request
401 - Unauthorized
403 - Forbidden
409 - Conflict
429 - Too Many Requests
Finds relationship types that are used by an asset, column or governance artifact
POST /v2/asset_relationship_types/search_used_ends
Finds relationship types that are used by an asset, column or a governance artifact. This API only returns the first page of results. It does not accept a bookmark. Any additional pages of results must be fetched using the next page url included in the response.<br/></br>You can refer to the options in the response to get the full list of relationship names.
Request
Path Parameters
Query Parameters
catalog_id
string
Catalog ID
project_id
string
Project ID
space_id
string
Space ID
asset_id
string
Asset ID
artifact_id
string
Artifact ID
artifact_type
string
Artifact Type
limit
integer
Optional limit to use when finding relationship types
lookup_related_item_types
boolean
Includes a list of the related asset types and artifact types in the result. This option adds overhead, so enable it only if the related type information is needed.
orderby
array
orderby. This parameter can be repeated to add additional sort fields. <br><br>Default: relationship_display_name_asc
Supported sort fields (these are case insensitive):
- relationship_name_asc
- relationship_name_desc
- relationship_display_name_asc
- relationship_display_name_desc
- create_time_asc
- create_time_desc
Response
200 - Success
options
object
related_artifact_types
array
related_asset_types
array
related_column_types
array
resources
array
total_rows
integer
next
object
400 - Bad Request
401 - Unauthorized
403 - Forbidden
409 - Conflict
429 - Too Many Requests
DELETE /v2/asset_relationship_types/{relationship_type_id}
Deletes a relationship type.
Request
Path Parameters
relationship_type_id
Required *
string
Query Parameters
Response
204 - No Content
400 - Bad Request
401 - Unauthorized
403 - Forbidden
409 - Conflict
429 - Too Many Request
``` [ { "op": "add", "path": "/end2/localized_display_name", "value": {" "en-us": "English Display Name" } } ] ```
Add a display name to an endpoint with an existing `localized_display_name` element:
``` [ { "op": "add", "path": "/end2/localized_display_name/en-gb", "value": "British Display Name", } ] ```
Change localized display name for en-gb in end2:"
``` [ { "op": "replace", "path": "/end2/localized_display_name/en-gb", "value": "New British Display Name" } ] ```
Remove localized display name for en-gb rom end1:
``` [ { "op": "remove", "path": "/end1/localized_display_name/en-gb" } ] ```
Add a relationship option override, replace an existing relationship option override, delete an existing relationship option override:
``` [ { "op": "add", "path": "/end1/option_overrides/-", "value": { "this_asset_type": "ibm_bi_report", "other_asset_type": "ibm_bi_report_query", "on_delete": "CASCADE", "on_publish": "IGNORE", "on_promote": "CASCADE", "on_clone": "IGNORE" } }, { "op": "replace", "path": "/end1/option_overrides/1/on_delete", "value": "CASCADE" }, { "op": "add", "path": "/end1/option_overrides/1/on_promote", "value": "IGNORE" }, { "op": "remove", "path": "/end1/option_overrides/1/on_promote" } [ ``` ">
Patches a relationship type
PATCH /v2/asset_relationship_types/{relationship_type_id}
Updates an existing relationship type. The patch body must be an array of json patch operations as defined in RFC 6902.
The following fields can be patched in each relationship type endpoint:
- `default_display_name` (value can be changed but not removed)
- `localized_display_name` (values can be added, changed, and removed)
- `on_delete` (value can be added, removed, or deleted)
Relationship types where at least one endpoint is a catalog asset type can be patched either by an admin member of the catalog, or by a user in the catalog's BSS account. Global relationship types can only be patched by a user with permission to create global asset types.
It is important to note that the patch specifies updates to apply the current json representation of the relationship types. When specifying an add/replace/remove patch operation, all of parent elements in the path must already exist. In particular, if the relationship type endpoint was originally created without a `localized_display_name` element, that element needs to be created by the patch operations.
Here are some examples of patches that can be applied:
Add a display name to an endpoint without an existing `localized_display_name` element:
``` [ { "op": "add", "path": "/end2/localized_display_name", "value": {" "en-us": "English Display Name" } } ] ```
Add a display name to an endpoint with an existing `localized_display_name` element:
``` [ { "op": "add", "path": "/end2/localized_display_name/en-gb", "value": "British Display Name", } ] ```
Change localized display name for en-gb in end2:"
``` [ { "op": "replace", "path": "/end2/localized_display_name/en-gb", "value": "New British Display Name" } ] ```
Remove localized display name for en-gb rom end1:
``` [ { "op": "remove", "path": "/end1/localized_display_name/en-gb" } ] ```
Add a relationship option override, replace an existing relationship option override, delete an existing relationship option override:
``` [ { "op": "add", "path": "/end1/option_overrides/-", "value": { "this_asset_type": "ibm_bi_report", "other_asset_type": "ibm_bi_report_query", "on_delete": "CASCADE", "on_publish": "IGNORE", "on_promote": "CASCADE", "on_clone": "IGNORE" } }, { "op": "replace", "path": "/end1/option_overrides/1/on_delete", "value": "CASCADE" }, { "op": "add", "path": "/end1/option_overrides/1/on_promote", "value": "IGNORE" }, { "op": "remove", "path": "/end1/option_overrides/1/on_promote" } [ ```
Request
Request Body
JSON array of patch operations as defined in RFC 6902.
Note: Any ‘~’ characters need to be escaped as ~0 in the path field.
Any ‘/’ characters need to be escaped as ~1 in the path field.
For example, in `{"foo/" : {"~bar" : "value"}}`, the path for `"~bar"` is `"/foo~1/~0bar"`.
Path Parameters
relationship_type_id
Required *
string
relationship_type_id
Query Parameters
Response
200 - Relationship type was successfully patched
metadata
object
relationship type metadata
entity
object
relationship type entity
400 - Bad Request
401 - Unauthorized
403 - Forbidden
409 - Conflict
429 - Too Many Requests
List all asset types defined for an account, catalog, project or space.
GET /v2/asset_types
Get all asset types in an account, catalog, project or space. Custom properties added/updated at the account level asset types can only be fetched if bss_account_id parameter is passed
Request
Path Parameters
Query Parameters
catalog_id
string
This parameter allows retrieving catalog-scoped asset types. You must provide either a catalog_id, a project_id, a space_id, OR a bss_account_id but not more than one.
project_id
string
This parameter allows retrieving project-scoped asset types. You must provide either a catalog_id, a project_id, a space_id, OR a bss_account_id but not more than one.
space_id
string
This parameter allows retrieving space-scoped asset types. You must provide either a catalog_id, a project_id, a space_id, OR a bss_account_id but not more than one.
bss_account_id
string
This parameter allows retrieving account-scoped asset types. May be different than account of user specified in Bearer token. You must provide either a catalog_id, a project_id, a space_id, OR a bss_account_id but not more than one.
permits_decorators
boolean
This parameter allows to retrieve asset types which can be decorated. You can provide either a true or a false.
custom_attributes
boolean
This parameter allows to retrieve asset types which can be used only as attributes and are user defined. You can provide either a true or a false. At a time, either permits_decorators or custom_attributes can be true.
locale
string
Language code, such as default, en, etc.
Response
200 - OK
resources
array
400 - Bad Request
401 - Unauthorized
403 - Forbidden
500 - Internal Server Error
Creates an asset type in an account, catalog, project or space.
POST /v2/asset_types
Creates an asset type in account, catalog, project or space.
Request
Request Body
CatalogCreationType
Asset Type request body
description
string
Asset type description
fields
Required *
array
Fields that are indexed if present in the asset.
external_asset_preview
object
External Asset Preview. Clients can make use of this to render content appropriately for this asset type.
base_client_url
Required *
string
Base client URL
url_parameters_from_asset_attributes
array
URL parameters
url_path_from_asset_attributes
string
URL path
url_parameters_fixed
string
URL parameters fixed
relationships
array
Relationship definitions for this asset type.
properties
object
Provides the IKC UI with information about displaying properties that can be present in the asset
localized_metadata_attributes
object
Example "localized_metadata_attributes": { "name": { "default": "Data Asset", "en": "Data Asset", "fr": "Data Asset" } }
decorates
array
List of pointers to types this type can decorate.
identity
object
Identity definition of the assets of the type
strategy
string
The strategy for detecting duplicate asset of the type
global_search_searchable
array
List of fields made searchable through Global Search functionality
attribute_behavior
object
Define the behavior only if this asset type is used as an attribute.
remove_on_copy
boolean
Remove the attribute when cloning, publishing or promoting the asset
attribute_only
boolean
If set to true, the type definition will be custom attributes, which can be used to decorate other asset types and cannot create this as a top level asset of this asset type. If set to false, the type definition will be custom asset type, which can be used to create top level assets of this asset type and/or also decorate other asset types.
data_protection
object
Asset type properties and attachments that should be filtered out for users without data access
all_fields
boolean
Indicates if all fields of the asset type are protected. If 'all_fields' is true, then 'fields' is ignored.
all_attachments
boolean
Indicates if all attachments of the asset type are protected. If 'all_attachments' is true, then 'attachment_types' is ignored.
field_search_paths
array
List of json paths that lead to the fields to be protected. e.g., "scoring.input_data", "columns[].name", "columns[0].code", "*.connection_id", etc. If 'all_fields' is true, then 'field_search_paths' is ignored.
attachment_types
array
List of types of attachments of the asset type to be protected. If 'all_attachments' is true, then 'attachment_types' is ignored.
is_column_custom_attribute
boolean
Set it to true if this is to be used for column custom attributes. Set to false if this is used for asset types or attribute. If true, allow_decorators should be false.
can_have_image
boolean
Set it to true if the type is expected to support uploading of images, else set it to false.
icon_id
string
Name/id of the svg image to be used as the icon for the to be created asset type.
version
number
The version of defined asset type
name
Required *
string
Asset type name
allow_decorators
boolean
Path Parameters
Query Parameters
catalog_id
string
This parameter allows the creation of a catalog-scoped asset type. You must provide either a catalog_id, a project_id, a space_id, OR a bss_account_id but not more than one.
project_id
string
This parameter allows the creation of a project-scoped asset type. You must provide either a catalog_id, a project_id, a space_id, OR a bss_account_id but not more than one.
space_id
string
This parameter allows the creation of a space-scoped asset type. You must provide either a catalog_id, a project_id, a space_id, OR a bss_account_id but not more than one.
bss_account_id
string
This parameter allows the creation of an account-scoped asset type. May be different than account of user specified in Bearer token. You must provide either a catalog_id, a project_id, a space_id, OR a bss_account_id but not more than one.
Response
201 - Created
description
string
Asset type description
fields
array
Fields that are indexed if present in the asset.
external_asset_preview
object
External Asset Preview. Clients can make use of this to render content appropriately for this asset type.
relationships
array
Relationship definitions for this asset type.
properties
object
Provides the IKC UI with information about displaying properties that can be present in the asset
localized_metadata_attributes
object
Example "localized_metadata_attributes": { "name": { "default": "Data Asset", "en": "Data Asset", "fr": "Data Asset" } }
decorates
array
List of pointers to types this type can decorate.
identity
object
Identity definition of the assets of the type
global_search_searchable
array
List of fields made searchable through Global Search functionality
attribute_behavior
object
Define the behavior only if this asset type is used as an attribute.
attribute_only
boolean
If set to true, the type definition will be custom attributes, which can be used to decorate other asset types and cannot create this as a top level asset of this asset type. If set to false, the type definition will be custom asset type, which can be used to create top level assets of this asset type and/or also decorate other asset types.
data_protection
object
Asset type properties and attachments that should be filtered out for users without data access
is_column_custom_attribute
boolean
Set it to true if this is to be used for column custom attributes. Set to false if this is used for asset types or attribute. If true, allow_decorators should be false.
can_have_image
boolean
Set it to true if the type is expected to support uploading of images, else set it to false.
icon_id
string
Name/id of the svg image to be used as the icon for the to be created asset type.
version
number
The version of defined asset type
name
string
Asset type name
scope
string
The scope of defined asset type. Derived-field. Will be one of GLOBAL, ACCOUNT, CATALOG, PROJECT, or SPACE.
decorated_by
array
List of pointers to types this type can be decorated by.
allow_decorators
boolean
202 - Accepted - indicates the asset type creation is being completed in the background
description
string
Asset type description
fields
array
Fields that are indexed if present in the asset.
external_asset_preview
object
External Asset Preview. Clients can make use of this to render content appropriately for this asset type.
relationships
array
Relationship definitions for this asset type.
properties
object
Provides the IKC UI with information about displaying properties that can be present in the asset
localized_metadata_attributes
object
Example "localized_metadata_attributes": { "name": { "default": "Data Asset", "en": "Data Asset", "fr": "Data Asset" } }
decorates
array
List of pointers to types this type can decorate.
identity
object
Identity definition of the assets of the type
global_search_searchable
array
List of fields made searchable through Global Search functionality
attribute_behavior
object
Define the behavior only if this asset type is used as an attribute.
attribute_only
boolean
If set to true, the type definition will be custom attributes, which can be used to decorate other asset types and cannot create this as a top level asset of this asset type. If set to false, the type definition will be custom asset type, which can be used to create top level assets of this asset type and/or also decorate other asset types.
data_protection
object
Asset type properties and attachments that should be filtered out for users without data access
is_column_custom_attribute
boolean
Set it to true if this is to be used for column custom attributes. Set to false if this is used for asset types or attribute. If true, allow_decorators should be false.
can_have_image
boolean
Set it to true if the type is expected to support uploading of images, else set it to false.
icon_id
string
Name/id of the svg image to be used as the icon for the to be created asset type.
version
number
The version of defined asset type
name
string
Asset type name
scope
string
The scope of defined asset type. Derived-field. Will be one of GLOBAL, ACCOUNT, CATALOG, PROJECT, or SPACE.
decorated_by
array
List of pointers to types this type can be decorated by.
allow_decorators
boolean
400 - Bad Request
401 - Unauthorized
403 - Forbidden
409 - Conflict
429 - Too Many Request
Retrieves an asset type of a given name.
GET /v2/asset_types/{type_name}
Retrieves an asset type of a given name. Custom properties added/updated at the account level asset types can only be fetched if bss_account_id parameter is passed
Request
Path Parameters
type_name
Required *
string
Asset Type name (eg: data_asset)
Query Parameters
catalog_id
string
This parameter allows retrieving a catalog-scoped asset type. You must provide either a catalog_id, a project_id, a space_id, OR a bss_account_id but not more than one.
project_id
string
This parameter allows retrieving a project-scoped asset type. You must provide either a catalog_id, a project_id, a space_id, OR a bss_account_id but not more than one.
space_id
string
This parameter allows retrieving a space-scoped asset type. You must provide either a catalog_id, a project_id, a space_id, OR a bss_account_id but not more than one.
bss_account_id
string
This parameter allows retrieving an account-scoped asset type. May be different than account of user specified in Bearer token. You must provide either a catalog_id, a project_id, a space_id, OR a bss_account_id but not more than one.
locale
string
Language code, such as default, en, etc.
search_scopes
array
This parameter can have one or more values as below:
- GLOBAL - return asset type in global scope
- BSS_ACCOUNT - return asset type in account scope
- CONTAINER - return asset type in catalog/ project/ space scope
If no value is provided, the default value is taken as null, and the asset type with the highest search scope is returned. A combination of more than one search scope is also valid. In this case, an asset type with the highest search scope from the given scopes will be returned.
Response
200 - OK
description
string
Asset type description
fields
array
Fields that are indexed if present in the asset.
external_asset_preview
object
External Asset Preview. Clients can make use of this to render content appropriately for this asset type.
relationships
array
Relationship definitions for this asset type.
properties
object
Provides the IKC UI with information about displaying properties that can be present in the asset
localized_metadata_attributes
object
Example "localized_metadata_attributes": { "name": { "default": "Data Asset", "en": "Data Asset", "fr": "Data Asset" } }
decorates
array
List of pointers to types this type can decorate.
identity
object
Identity definition of the assets of the type
global_search_searchable
array
List of fields made searchable through Global Search functionality
attribute_behavior
object
Define the behavior only if this asset type is used as an attribute.
attribute_only
boolean
If set to true, the type definition will be custom attributes, which can be used to decorate other asset types and cannot create this as a top level asset of this asset type. If set to false, the type definition will be custom asset type, which can be used to create top level assets of this asset type and/or also decorate other asset types.
data_protection
object
Asset type properties and attachments that should be filtered out for users without data access
is_column_custom_attribute
boolean
Set it to true if this is to be used for column custom attributes. Set to false if this is used for asset types or attribute. If true, allow_decorators should be false.
can_have_image
boolean
Set it to true if the type is expected to support uploading of images, else set it to false.
icon_id
string
Name/id of the svg image to be used as the icon for the to be created asset type.
version
number
The version of defined asset type
name
string
Asset type name
scope
string
The scope of defined asset type. Derived-field. Will be one of GLOBAL, ACCOUNT, CATALOG, PROJECT, or SPACE.
decorated_by
array
List of pointers to types this type can be decorated by.
allow_decorators
boolean
400 - Bad Request
401 - Unauthorized
403 - Forbidden
404 - Not Found
Replace an asset type
PUT /v2/asset_types/{type_name}
Replace asset attributes for the given asset type or create a new asset type if the given asset type does not exist.
Request
Request Body
CatalogUpdateType
Asset Type request body
description
string
Asset type description
fields
Required *
array
Fields that are indexed if present in the asset.
external_asset_preview
object
External Asset Preview. Clients can make use of this to render content appropriately for this asset type.
base_client_url
Required *
string
Base client URL
url_parameters_from_asset_attributes
array
URL parameters
url_path_from_asset_attributes
string
URL path
url_parameters_fixed
string
URL parameters fixed
relationships
array
Relationship definitions for this asset type.
properties
object
Provides the IKC UI with information about displaying properties that can be present in the asset
localized_metadata_attributes
object
Example "localized_metadata_attributes": { "name": { "default": "Data Asset", "en": "Data Asset", "fr": "Data Asset" } }
decorates
array
List of pointers to types this type can decorate.
identity
object
Identity definition of the assets of the type
strategy
string
The strategy for detecting duplicate asset of the type
global_search_searchable
array
List of fields made searchable through Global Search functionality
attribute_behavior
object
Define the behavior only if this asset type is used as an attribute.
remove_on_copy
boolean
Remove the attribute when cloning, publishing or promoting the asset
attribute_only
boolean
If set to true, the type definition will be custom attributes, which can be used to decorate other asset types and cannot create this as a top level asset of this asset type. If set to false, the type definition will be custom asset type, which can be used to create top level assets of this asset type and/or also decorate other asset types.
data_protection
object
Asset type properties and attachments that should be filtered out for users without data access
all_fields
boolean
Indicates if all fields of the asset type are protected. If 'all_fields' is true, then 'fields' is ignored.
all_attachments
boolean
Indicates if all attachments of the asset type are protected. If 'all_attachments' is true, then 'attachment_types' is ignored.
field_search_paths
array
List of json paths that lead to the fields to be protected. e.g., "scoring.input_data", "columns[].name", "columns[0].code", "*.connection_id", etc. If 'all_fields' is true, then 'field_search_paths' is ignored.
attachment_types
array
List of types of attachments of the asset type to be protected. If 'all_attachments' is true, then 'attachment_types' is ignored.
is_column_custom_attribute
boolean
Set it to true if this is to be used for column custom attributes. Set to false if this is used for asset types or attribute. If true, allow_decorators should be false.
can_have_image
boolean
Set it to true if the type is expected to support uploading of images, else set it to false.
icon_id
string
Name/id of the svg image to be used as the icon for the to be created asset type.
allow_decorators
boolean
Path Parameters
type_name
Required *
string
Asset Type name (eg: data_asset)
Query Parameters
catalog_id
string
This parameter allows creating or updating a catalog-scoped asset type. You must provide either a catalog_id, a project_id, a space_id, OR a bss_account_id but not more than one.
project_id
string
This parameter allows creating or updating a project-scoped asset type. You must provide either a catalog_id, a project_id, a space_id, OR a bss_account_id but not more than one.
space_id
string
This parameter allows creating or updating a space-scoped asset type. You must provide either a catalog_id, a project_id, a space_id, OR a bss_account_id but not more than one.
bss_account_id
string
This parameter allows creating or updating an account-scoped asset type. May be different than account of user specified in Bearer token. You must provide either a catalog_id, a project_id, a space_id, OR a bss_account_id but not more than one.
Response
200 - OK
description
string
Asset type description
fields
array
Fields that are indexed if present in the asset.
external_asset_preview
object
External Asset Preview. Clients can make use of this to render content appropriately for this asset type.
relationships
array
Relationship definitions for this asset type.
properties
object
Provides the IKC UI with information about displaying properties that can be present in the asset
localized_metadata_attributes
object
Example "localized_metadata_attributes": { "name": { "default": "Data Asset", "en": "Data Asset", "fr": "Data Asset" } }
decorates
array
List of pointers to types this type can decorate.
identity
object
Identity definition of the assets of the type
global_search_searchable
array
List of fields made searchable through Global Search functionality
attribute_behavior
object
Define the behavior only if this asset type is used as an attribute.
attribute_only
boolean
If set to true, the type definition will be custom attributes, which can be used to decorate other asset types and cannot create this as a top level asset of this asset type. If set to false, the type definition will be custom asset type, which can be used to create top level assets of this asset type and/or also decorate other asset types.
data_protection
object
Asset type properties and attachments that should be filtered out for users without data access
is_column_custom_attribute
boolean
Set it to true if this is to be used for column custom attributes. Set to false if this is used for asset types or attribute. If true, allow_decorators should be false.
can_have_image
boolean
Set it to true if the type is expected to support uploading of images, else set it to false.
icon_id
string
Name/id of the svg image to be used as the icon for the to be created asset type.
version
number
The version of defined asset type
name
string
Asset type name
scope
string
The scope of defined asset type. Derived-field. Will be one of GLOBAL, ACCOUNT, CATALOG, PROJECT, or SPACE.
decorated_by
array
List of pointers to types this type can be decorated by.
allow_decorators
boolean
202 - Accepted
description
string
Asset type description
fields
array
Fields that are indexed if present in the asset.
external_asset_preview
object
External Asset Preview. Clients can make use of this to render content appropriately for this asset type.
relationships
array
Relationship definitions for this asset type.
properties
object
Provides the IKC UI with information about displaying properties that can be present in the asset
localized_metadata_attributes
object
Example "localized_metadata_attributes": { "name": { "default": "Data Asset", "en": "Data Asset", "fr": "Data Asset" } }
decorates
array
List of pointers to types this type can decorate.
identity
object
Identity definition of the assets of the type
global_search_searchable
array
List of fields made searchable through Global Search functionality
attribute_behavior
object
Define the behavior only if this asset type is used as an attribute.
attribute_only
boolean
If set to true, the type definition will be custom attributes, which can be used to decorate other asset types and cannot create this as a top level asset of this asset type. If set to false, the type definition will be custom asset type, which can be used to create top level assets of this asset type and/or also decorate other asset types.
data_protection
object
Asset type properties and attachments that should be filtered out for users without data access
is_column_custom_attribute
boolean
Set it to true if this is to be used for column custom attributes. Set to false if this is used for asset types or attribute. If true, allow_decorators should be false.
can_have_image
boolean
Set it to true if the type is expected to support uploading of images, else set it to false.
icon_id
string
Name/id of the svg image to be used as the icon for the to be created asset type.
version
number
The version of defined asset type
name
string
Asset type name
scope
string
The scope of defined asset type. Derived-field. Will be one of GLOBAL, ACCOUNT, CATALOG, PROJECT, or SPACE.
decorated_by
array
List of pointers to types this type can be decorated by.
allow_decorators
boolean
400 - Bad Request
401 - Unauthorized
403 - Forbidden
404 - Not Found
409 - Conflict
429 - Too Many Request
500 - Internal Server Error
Deletes an asset type
DELETE /v2/asset_types/{type_name}
Deletes an asset type in given account or container. Note that, deletion of an account scope asset type or a container scope asset type triggers background clean up of assets:<br/><ul><li>Assets of this type are deleted.</li><li>And in case of other assets, attributes of this type are removed.</li></ul>
Request
Path Parameters
type_name
Required *
string
Asset Type name (eg: data_asset)
Query Parameters
catalog_id
string
This parameter allows creating or updating a catalog-scoped asset type. You must provide either a catalog_id, a project_id, a space_id, OR a bss_account_id but not more than one.
project_id
string
This parameter allows creating or updating a project-scoped asset type. You must provide either a catalog_id, a project_id, a space_id, OR a bss_account_id but not more than one.
space_id
string
This parameter allows creating or updating a space-scoped asset type. You must provide either a catalog_id, a project_id, a space_id, OR a bss_account_id but not more than one.
bss_account_id
string
This parameter allows creating or updating an account-scoped asset type. May be different than account of user specified in Bearer token. You must provide either a catalog_id, a project_id, a space_id, OR a bss_account_id but not more than one.
Response
200 - OK
202 - Accepted
400 - Bad Request
401 - Unauthorized
403 - Forbidden
404 - Not Found
409 - Conflict
429 - Too Many Request
500 - Internal Server Error
Finds relationship types for an asset type
GET /v2/asset_types/{type_name}/relationships
Finds relationship types that originate from a given asset type. This API supports limiting the results to a specific set of relationship types as well as providing pagination and sorting options. It also supports finding relationship types that use both global and catalog asset types.<br>This API is deprecated - use `POST /v2/asset_relationship_types/search_ends` instead
Request
Path Parameters
type_name
Required *
string
type_name. This specifies the asset type whose relationships should be found.
Query Parameters
catalog_id
string
catalog_id. If set, this restricts catalog asset types in the result to the given catalog. If no container parameters are set, any asset container the user has access to are allowed.
project_id
string
catalog_id. If set, this restricts catalog asset types in the result to the given project. If no container parameters are set, any asset containers the user has access to are allowed.
space_id
string
catalog_id. If set, this restricts catalog asset types in the result to the given space. If no container parameters are set, any asset containers the user has access to are allowed.
limit
integer
Optional limit to use when finding relationship types
bookmark
string
Optional bookmark to use when finding relationship types.
orderby
array
orderby. This parameter can be repeated to add additional sort fields. <br><br>Default: relationship_display_name_asc
Supported sort fields (these are case insensitive):
- relationship_name_asc
- relationship_name_desc
- relationship_display_name_asc
- relationship_display_name_desc
- create_time_asc
- create_time_desc
relname
array
Limits results to only include the specified relationships. By default, all relationship types for the asset type are included. Repeat the query parameter to specify multiple relationship names.
Response
200 - Success
options
object
related_artifact_types
array
related_asset_types
array
related_column_types
array
resources
array
total_rows
integer
next
object
400 - Bad Request
401 - Unauthorized
403 - Forbidden
409 - Conflict
429 - Too Many Requests
POST /v2/asset_types/{type_name}/search
Use this API to search for assets of the generic asset type (asset) or any specific asset type in a Catalog, Space, or Project.
The request body must contain a `query` field, which specifies a Lucene query to search for assets on indexed fields.<br/> See <b>Searchable Asset and Attachment Fields</b> below for the list of fields that can be searched in the query.<br/>
If `query` contains no selection criteria (`":"`), then the result includes all assets that are instances of the type specified in the `type_name` path parameter, including assets whose primary asset type (i.e. its `metadata.asset_type` value) is that type, and assets that have an attribute of that type.<br/> To filter out assets whose primary type does not match the `type_name` parameter, the query must include an `asset.asset_type:{type_name}` predicate.
The query results can be sorted by specifying a `sort` field in the request with format `field<sort_type>`. The `sort_type` can be either `number` or `string` (e.g. `"sort" : "asset.name<string>"`).
<b> Search With Pagination </b>
The `limit` request body field can be specified to limit the number of assets in the search results.<br/> The default `limit` is 200. The maximum `limit` value is 200, and any greater value is ignored.<br/>
Sample Request Body: ``` { "query" : "asset.name:Asset*", "limit" : 2, "sort" : "asset.name<string>" } ```
Response: ``` { "next": { "bookmark": "g1AAAXXXXXXXX", "query" : "asset.name:Asset*", "limit" : 2, "sort" : "asset.name<string>" }, "results": [ { ..asset 1... }, { ..asset 2... } ], "total_rows": 3 } ```
When more search results are available, then the response will contain a `next` JSON object - `next` contains `bookmark` along with original query which needs to be returned to retrieve the next page of results. To paginate through the entire result set, the request should be re-executed with the `bookmark` from the `next.bookmark` value of the previous response until there is no `next` object in the response (note that this response may contain an empty `results` array).
Sample request body to get the next page of results: ``` { "bookmark": "g1AAAXXXXXXXX", "query" : "asset.name:Asset*", "limit" : 2, "sort" : "asset.name<string>" } ```
<b>Searchable Asset and Attachment Fields</b>
The following asset and attachment fields can be searched in the query - note that type `<string>` or `<number>` only needs to be added for use in the `sort` request field:<br/> `asset.asset_attributes<string>`<br/> `asset.asset_category<string>`<br/> `asset.asset_state<string>`<br/> `asset.asset_type<string>`<br/> `asset.catalog_id<string>`<br/> `asset.created_at<string>`<br/> `asset.delete_timestamp<string>`<br/> `asset.description<string>`<br/> `asset.memberIds<string>`<br/> `asset.editor_id<string>`<br/> `asset.viewer_id<string>`<br/> `asset.member_or_owner_id<string>`<br/> `asset.memberGroupIds<string>`<br/> `asset.editor_group_id<string>`<br/> `asset.viewer_group_id<string>`<br/> `asset.member_or_owner_group_id<string>`<br/> `asset.mode<number>`<br/> `asset.name<string>`<br/> `asset.owner_id<string>`<br/> `asset.owner_group_id<string>`<br/> `asset.project_id<string>`<br/> `asset.rating<number>`<br/> `asset.resource_key<string>`<br/> `asset.identity_key<string>`<br/> `asset.source_asset_id<string>`<br/> `asset.source_catalog_id<string>`<br/> `asset.source_project_id<string>`<br/> `asset.source_space_id<string>`<br/> `asset.source_system<string>`<br/> `asset.source_system_asset_id<string>`<br/> `asset.source_system_created_at<string>`<br/> `asset.source_system_id<string>`<br/> `asset.source_history_asset_id<string>`<br/> `asset.source_history_system_id<string>`<br/> `asset.space_id<string>`<br/> `asset.tags<string>`<br/> `attachment.connection_id<string>`<br/> `attachment.connection_path<string>`<br/> `attachment.name<string>`<br/> `attachment.object_key<string>`<br/>
Request
Request Body
CatalogCatalogSearch
Search Criteria. The "include" field in the request body is a list of asset sections to include in the search results, values are comma-separated and the supported values are "entity" or "entity,attachments".
query
Required *
string
Lucene query
limit
integer
counts
array
Returns the number of query results for each unique value of each named field.
drilldown
array
Restrict results to documents with a dimension equal to the specified label. Note that, multiple values for a single key in a drilldown means an OR relation between them and there is an AND relation between multiple keys.
bookmark
string
Bookmark of the query result
sort
string
Sort order for the query
include
string
entity
Path Parameters
type_name
Required *
string
Asset Type name (eg: data_asset)
Query Parameters
catalog_id
string
You must provide either a catalog id, a project id, or a space id, but not more than one
project_id
string
You must provide either a catalog id, a project id, or a space id, but not more than one
space_id
string
You must provide either a catalog id, a project id, or a space id, but not more than one
hide_deprecated_response_fields
boolean
Defaults to false. If true, deprecated fields are not included in the response. This parameter is provided as a way to check compatibility with future releases and remove duplicated information from responses. It has not been implemented for all deprecated fields. The primary fields that are omitted are collaborator_ids in the asset metadata rov and the owner_id field in the asset metadata.
include
string
The parameter `include` is deprecated, please use `exclude` instead
exclude
string
Exclude columns from the asset result. Available value: columns. Default value is empty, which will return the complete asset, including the columns.
Response
200 - OK
next
CatalogCatalogSearch
Catalog Search Model
total_rows
integer
results
array
400 - Bad Request
401 - Unauthorized
403 - Forbidden
Get the status of an account scope or global scope asset type.
GET /v2/asset_types/{type_name}/status
Retrieves an account scope or global scope status, If bss_account_id is not provided, api will try to retreive status of an asset type at global level if present.
Request
Path Parameters
type_name
Required *
string
Asset Type name (eg: account_type)
Query Parameters
bss_account_id
string
This parameter allows retrieving status of an account-scoped asset type. May be different than account of user specified in Bearer token.
Response
200 - OK
name
string
status
string
303 - See Other
400 - Bad Request
401 - Unauthorized
403 - Forbidden
404 - Not Found
Create an asset
POST /v2/assets
Use this API to create an asset in catalog or project. Assets contain information about the contents of your data and how to access the data. You store asset metadata in a catalog and add collaborators from your organization to analyze data. Your data can reside in a variety of sources. For example, you can keep your data in your existing on-premises data sources, cloud data services, or streaming data feeds. By adding connection information to these remote sources in the catalog, you can allow other catalog users to access the data with the stored credentials. Alternatively, you can copy a snapshot of the remote data into the catalog's encrypted cloud storage.<br/>All asset types have a common set of properties. Some asset types have additional properties.<br/>When you add an asset to a catalog, you specify these common properties:
- The asset name and an optional description. The name can only contain letters, numbers, underscore, dash, space, and period. The name can't be only blank spaces.
- Privacy. You can choose to restrict access to the asset with the privacy level and asset membership.
- Public = Default. No restrictions on finding or using the asset.
- Private = Only asset members can find or use the asset.
- Members. The catalog collaborators can be added as members of the asset. Members are important if you restrict access to the asset. When you create an asset, you are the owner (and implicitly a member) of it. Members can be set in metadata/rov/collaborator_ids or metadata/rov/member_roles, but not both. Members set in metadata/rov/member_roles are given an explicit set of roles. Members can have up to two roles: OWNER and either EDITOR or VIEWER. Only service ids can assign the OWNER role. The request to add the OWNER role is ignored for other callers. Asset members with the EDITOR or VIEWER role must also be members of the catalog. Members set in metadata/rov/collaborator_ids are automatically assigned a role based on their role in the catalog.
- Tags. Metadata that makes searching for the asset easier. Tags can contain only letters, numbers, underscores, dashes, and the symbols # and @.
Request
Request Body
CatalogAsset
Asset metadata
metadata
CatalogAssetMetadata
AssetMetadata Model
name
Required *
string
Choose Any Name for your Asset
description
string
A longer description describes an asset.
tags
array
asset_type
Required *
string
asset type
origin_country
string
resource_key
string
identity_key
string
rov
object
asset_category
Required *
string
source_system
object
Source System Info
child_source_systems
array
source_system_history
array
History of external repository assets that were the source of an imported/synced/rehomed asset.
entity
Required *
object
attachments
array
Path Parameters
Query Parameters
catalog_id
string
You must provide either a catalog id, a project id, or a space id, but not more than one
project_id
string
You must provide either a catalog id, a project id, or a space id, but not more than one
space_id
string
You must provide either a catalog id, a project id, or a space id, but not more than one
duplicate_action
string
Action to take if the call would result in a duplicate asset. `IGNORE` means the call will ignore the duplicate and create a new asset. `REJECT` means the call will fail and no asset will be created. `UPDATE` means the best matched duplicate will be updated with the incoming changes according to the predefined rules. `REPLACE` means the best matched duplicate will be overwritten with the input values according to the predefined rules. No value means the duplicate_action specified in catalogs/projects/spaces will be used.
hide_deprecated_response_fields
boolean
Defaults to false. If true, deprecated fields are not included in the response. This parameter is provided as a way to check compatibility with future releases and remove duplicated information from responses. It has not been implemented for all deprecated fields. The primary fields that are omitted are collaborator_ids in the asset metadata rov and the owner_id field in the asset metadata.
Response
201 - Created
metadata
CatalogResponseAssetMetadata
entity
object
href
string
attachments
CatalogAttachment
asset_id
string
400 - Bad Request
401 - Unauthorized
403 - Forbidden
500 - Internal Server Error
GET /v2/assets/bulk
Use this API to retrieve one or more assets located in catalog or project or space. Access to an asset is controlled by a combination of the privacy level and the members of the asset. For a governed catalog, data assets are protected from unauthorized access by the governance policies that are defined in Data Governance. Data assets in ungoverned catalogs are not subject to governance policies.<br/><br/>Response includes, for each asset, asset ID, status, HTTP status and, if no errors, asset details & relationship count or list of errors. For example:
``` { "resources":[ { "asset_id":"cf38d92c-eb55-462e-89bf-cdb9fe67f0b7", "status":"success", "http_status":200, "asset":{...}, "relationship_count":2 }, { "asset_id":"c6650020-3176-4d67-8fbe-5a19ba1c2c7e", "status":"failed", "http_status":404, "errors":[ ... ] }, ... ] } ```
Request
Path Parameters
Query Parameters
catalog_id
string
You must provide either a catalog id, a project id, or a space id, but not more than one
project_id
string
You must provide either a catalog id, a project id, or a space id, but not more than one
space_id
string
You must provide either a catalog id, a project id, or a space id, but not more than one
asset_ids
Required *
string
Comma separated list of asset IDs; maximum of 20. For assets with revisions, an optional revision number can be specified using colon character in the form of '<asset id>:<revision>,<asset id>,...'. Revision numbers are non-zero positive numbers likes 1, 2, 3 etc.
allow_metadata_on_dpr_deny
boolean
Whether to allow access to metadata when the evaluation outcome of data protection rules is Deny.
include
string
The parameter `include` is deprecated, please use `exclude` instead
exclude
string
Exclude columns from the asset result. Available value: columns. Default value is empty, which will return the complete asset, including the columns.
hide_deprecated_response_fields
boolean
Defaults to false. If true, deprecated fields are not included in the response. This parameter is provided as a way to check compatibility with future releases and remove duplicated information from responses. It has not been implemented for all deprecated fields. The primary fields that are omitted are collaborator_ids in the asset metadata rov and the owner_id field in the asset metadata.
include_relationship_count
boolean
Whether to include per-asset relationship count. Note: The default will be changed to 'false' in a later release.
include_source_columns
boolean
Whether to include relationships where source end is a column of the source asset in the asset's relationship counter.
Response
200 - OK
trace
string
resources
array
400 - Bad Request
401 - Unauthorized
403 - Forbidden
500 - Internal Server Error
DELETE /v2/assets/bulk
Use this API to delete assets. You can delete an asset if you are the owner of the asset or a member of the asset with Admin or Editor permissions on the catalog or project or space.
Purge Options to Delete Assets
purge_on_delete = true and purge_after_days is not specified: the asset is purged immediately. purge_on_delete = true and purge_after_days = n: the asset is moved to trash and purged after n days. purge_on_delete = false and purge_after_days is not specified: the asset is moved to trash and never purged. purge_on_delete is not specified and purge_after_days is not specified: the asset will be deleted/purged based on the catalog setting. purge_on_delete = false or is not specified and purge_after_days = n: invalid combination - the call will fail with a 400 Bad Request error.
Request
Path Parameters
Query Parameters
catalog_id
string
You must provide either a catalog id, a project id, or a space id, but not more than one
project_id
string
You must provide either a catalog id, a project id, or a space id, but not more than one
space_id
string
You must provide either a catalog id, a project id, or a space id, but not more than one
purge_on_delete
boolean
If true, asset is also deleted from the trash.
purge_after_days
integer
Number of days after which asset will be purged. Purge On Delete should be true for this to be valid
asset_ids
Required *
string
Comma separated list of asset IDs; maximum of 20.
Response
207 - Check response body for status of each asset being deleted
status
array
400 - Bad Request
401 - Unauthorized
403 - Forbidden
500 - Internal Server Error
Get assets membership for a specific user
GET /v2/assets/bulk/members/{member_id}
Returns any memberships this user has on assets, including direct membership and any access group memberships.
Request
Path Parameters
member_id
Required *
string
member_id
Query Parameters
catalog_id
string
You must provide either a catalog id, a project id, or a space id, but not more than one
project_id
string
You must provide either a catalog id, a project id, or a space id, but not more than one
space_id
string
You must provide either a catalog id, a project id, or a space id, but not more than one
asset_ids
Required *
string
Comma separated list of asset IDs; maximum of 25.
resolve_member_roles
boolean
[...]
